// Code generated by protoc-gen-go. DO NOT EDIT.
// source: api.proto

/*
Package kubevirt_hooks_info is a generated protocol buffer package.

It is generated from these files:
	api.proto

It has these top-level messages:
	InfoParams
	InfoResult
	HookPoint
*/
package kubevirt_hooks_info

import (
	fmt "fmt"

	proto "github.com/golang/protobuf/proto"

	math "math"

	context "golang.org/x/net/context"

	grpc "google.golang.org/grpc"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion2 // please upgrade the proto package

type InfoParams struct {
}

func (m *InfoParams) Reset()                    { *m = InfoParams{} }
func (m *InfoParams) String() string            { return proto.CompactTextString(m) }
func (*InfoParams) ProtoMessage()               {}
func (*InfoParams) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{0} }

type InfoResult struct {
	// name of the hook used by virt-launcher to compare it with requested hooks
	Name string `protobuf:"bytes,1,opt,name=name" json:"name,omitempty"`
	// hookPoints is a list of subscribed hook points
	HookPoints []*HookPoint `protobuf:"bytes,3,rep,name=hookPoints" json:"hookPoints,omitempty"`
	// versions is a list of implemented hook Callbacks service versions
	Versions []string `protobuf:"bytes,4,rep,name=versions" json:"versions,omitempty"`
}

func (m *InfoResult) Reset()                    { *m = InfoResult{} }
func (m *InfoResult) String() string            { return proto.CompactTextString(m) }
func (*InfoResult) ProtoMessage()               {}
func (*InfoResult) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{1} }

func (m *InfoResult) GetName() string {
	if m != nil {
		return m.Name
	}
	return ""
}

func (m *InfoResult) GetHookPoints() []*HookPoint {
	if m != nil {
		return m.HookPoints
	}
	return nil
}

func (m *InfoResult) GetVersions() []string {
	if m != nil {
		return m.Versions
	}
	return nil
}

type HookPoint struct {
	// name represents name of the subscribed hook point
	Name string `protobuf:"bytes,1,opt,name=name" json:"name,omitempty"`
	// priority is used to sort hooks prior to their execution (second key is the name)
	Priority int32 `protobuf:"varint,2,opt,name=priority" json:"priority,omitempty"`
}

func (m *HookPoint) Reset()                    { *m = HookPoint{} }
func (m *HookPoint) String() string            { return proto.CompactTextString(m) }
func (*HookPoint) ProtoMessage()               {}
func (*HookPoint) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{2} }

func (m *HookPoint) GetName() string {
	if m != nil {
		return m.Name
	}
	return ""
}

func (m *HookPoint) GetPriority() int32 {
	if m != nil {
		return m.Priority
	}
	return 0
}

func init() {
	proto.RegisterType((*InfoParams)(nil), "kubevirt.hooks.info.InfoParams")
	proto.RegisterType((*InfoResult)(nil), "kubevirt.hooks.info.InfoResult")
	proto.RegisterType((*HookPoint)(nil), "kubevirt.hooks.info.HookPoint")
}

// Reference imports to suppress errors if they are not otherwise used.
var _ context.Context
var _ grpc.ClientConn

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
const _ = grpc.SupportPackageIsVersion4

// Client API for Info service

type InfoClient interface {
	Info(ctx context.Context, in *InfoParams, opts ...grpc.CallOption) (*InfoResult, error)
}

type infoClient struct {
	cc *grpc.ClientConn
}

func NewInfoClient(cc *grpc.ClientConn) InfoClient {
	return &infoClient{cc}
}

func (c *infoClient) Info(ctx context.Context, in *InfoParams, opts ...grpc.CallOption) (*InfoResult, error) {
	out := new(InfoResult)
	err := grpc.Invoke(ctx, "/kubevirt.hooks.info.Info/Info", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for Info service

type InfoServer interface {
	Info(context.Context, *InfoParams) (*InfoResult, error)
}

func RegisterInfoServer(s *grpc.Server, srv InfoServer) {
	s.RegisterService(&_Info_serviceDesc, srv)
}

func _Info_Info_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(InfoParams)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(InfoServer).Info(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/kubevirt.hooks.info.Info/Info",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(InfoServer).Info(ctx, req.(*InfoParams))
	}
	return interceptor(ctx, in, info, handler)
}

var _Info_serviceDesc = grpc.ServiceDesc{
	ServiceName: "kubevirt.hooks.info.Info",
	HandlerType: (*InfoServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Info",
			Handler:    _Info_Info_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "api.proto",
}

func init() { proto.RegisterFile("api.proto", fileDescriptor0) }

var fileDescriptor0 = []byte{
	// 202 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xe2, 0xe2, 0x4c, 0x2c, 0xc8, 0xd4,
	0x2b, 0x28, 0xca, 0x2f, 0xc9, 0x17, 0x12, 0xce, 0x2e, 0x4d, 0x4a, 0x2d, 0xcb, 0x2c, 0x2a, 0xd1,
	0xcb, 0xc8, 0xcf, 0xcf, 0x2e, 0xd6, 0xcb, 0xcc, 0x4b, 0xcb, 0x57, 0xe2, 0xe1, 0xe2, 0xf2, 0xcc,
	0x4b, 0xcb, 0x0f, 0x48, 0x2c, 0x4a, 0xcc, 0x2d, 0x56, 0xaa, 0x81, 0xf0, 0x82, 0x52, 0x8b, 0x4b,
	0x73, 0x4a, 0x84, 0x84, 0xb8, 0x58, 0xf2, 0x12, 0x73, 0x53, 0x25, 0x18, 0x15, 0x18, 0x35, 0x38,
	0x83, 0xc0, 0x6c, 0x21, 0x3b, 0x2e, 0x2e, 0x90, 0xee, 0x80, 0xfc, 0xcc, 0xbc, 0x92, 0x62, 0x09,
	0x66, 0x05, 0x66, 0x0d, 0x6e, 0x23, 0x39, 0x3d, 0x2c, 0x26, 0xeb, 0x79, 0xc0, 0x94, 0x05, 0x21,
	0xe9, 0x10, 0x92, 0xe2, 0xe2, 0x28, 0x4b, 0x2d, 0x2a, 0xce, 0xcc, 0xcf, 0x2b, 0x96, 0x60, 0x51,
	0x60, 0xd6, 0xe0, 0x0c, 0x82, 0xf3, 0x95, 0xac, 0xb9, 0x38, 0xe1, 0x9a, 0xb0, 0x5a, 0x2e, 0xc5,
	0xc5, 0x51, 0x50, 0x94, 0x99, 0x5f, 0x94, 0x59, 0x52, 0x29, 0xc1, 0xa4, 0xc0, 0xa8, 0xc1, 0x1a,
	0x04, 0xe7, 0x1b, 0x05, 0x70, 0xb1, 0x80, 0x9c, 0x2e, 0xe4, 0x01, 0xa5, 0xe5, 0xb1, 0x3a, 0x0a,
	0xe1, 0x57, 0x29, 0xdc, 0x0a, 0x20, 0xde, 0x4f, 0x62, 0x03, 0x07, 0x9b, 0x31, 0x20, 0x00, 0x00,
	0xff, 0xff, 0x94, 0x8e, 0x0d, 0xdc, 0x43, 0x01, 0x00, 0x00,
}
